Loading...
Searching...
No Matches
pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

PrincipalCurvaturesEstimation estimates the directions (eigenvectors) and magnitudes (eigenvalues) of principal surface curvatures for a given point cloud dataset containing points and normals. More...

`#include <pcl/features/principal_curvatures.h>`

Inheritance diagram for pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >:

## Public Types

using | Ptr = shared_ptr<PrincipalCurvaturesEstimation<PointInT, PointNT, PointOutT> >
using | ConstPtr = shared_ptr<const PrincipalCurvaturesEstimation<PointInT, PointNT, PointOutT> >
using | PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut
using | PointCloudIn = pcl::PointCloud<PointInT>
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PrincipalCurvatures >
using | PointCloudN
using | PointCloudNPtr
using | PointCloudNConstPtr
using | Ptr
using | ConstPtr
Public Types inherited from pcl::Feature< PointInT, pcl::PrincipalCurvatures >
using | BaseClass
using | Ptr
using | ConstPtr
using | KdTree
using | KdTreePtr
using | PointCloudIn
using | PointCloudInPtr
using | PointCloudInConstPtr
using | PointCloudOut
using | SearchMethod
using | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| PrincipalCurvaturesEstimation (unsigned int nr_threads=1, int chunk_size=256)
| Initialize the scheduler and set the number of threads to use.
void | computePointPrincipalCurvatures (const pcl::PointCloud< PointNT > &normals, int p_idx, const pcl::Indices &indices, float &pcx, float &pcy, float &pcz, float &pc1, float &pc2)
| Perform Principal Components Analysis (PCA) on the point normals of a surface patch in the tangent plane of the given point normal, and return the principal curvature (eigenvector of the max eigenvalue), along with both the max (pc1) and min (pc2) eigenvalues.
void | setNumberOfThreads (unsigned int nr_threads)
| Initialize the scheduler and set the number of threads to use.
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PrincipalCurvatures >
| FeatureFromNormals ()
| Empty constructor.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset.
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset.
Public Member Functions inherited from pcl::Feature< PointInT, pcl::PrincipalCurvatures >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Estimate the principal curvature (eigenvector of the max eigenvalue), along with both the max (pc1) and min (pc2) eigenvalues for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PrincipalCurvatures >
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
Protected Member Functions inherited from pcl::Feature< PointInT, pcl::PrincipalCurvatures >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

unsigned int | threads_
| The number of threads the scheduler should use.
int | chunk_size_
| Chunk size for (dynamic) scheduling.
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, pcl::PrincipalCurvatures >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset.
Protected Attributes inherited from pcl::Feature< PointInT, pcl::PrincipalCurvatures >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>
class pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >

PrincipalCurvaturesEstimation estimates the directions (eigenvectors) and magnitudes (eigenvalues) of principal surface curvatures for a given point cloud dataset containing points and normals.

The output contains the principal curvature (eigenvector of the max eigenvalue), along with both the max (pc1) and min (pc2) eigenvalues. Parallel execution is supported through OpenMP.

The recommended PointOutT is pcl::PrincipalCurvatures.

Author
  Radu B. Rusu, Jared Glover, Alex Navarro

Definition at line 58 of file principal_curvatures.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

using pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::ConstPtr = shared_ptr<const PrincipalCurvaturesEstimation<PointInT, PointNT, PointOutT> >

Definition at line 62 of file principal_curvatures.h.

## PointCloudIn

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

using pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::PointCloudIn = pcl::PointCloud<PointInT>

Definition at line 73 of file principal_curvatures.h.

## PointCloudOut

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

using pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 72 of file principal_curvatures.h.

## Ptr

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

using pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::Ptr = shared_ptr<PrincipalCurvaturesEstimation<PointInT, PointNT, PointOutT> >

Definition at line 61 of file principal_curvatures.h.

## Constructor & Destructor Documentation

## PrincipalCurvaturesEstimation()

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::PrincipalCurvaturesEstimation | ( | unsigned int | nr_threads = 1,
|  | int | chunk_size = 256 )

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value to automatic)
  chunk_size | PCL will use dynamic scheduling with this chunk size. Setting it too low will lead to more parallelization overhead. Setting it too high will lead to a worse balancing between the threads.

Definition at line 81 of file principal_curvatures.h.

References chunk_size_, pcl::Feature< PointInT, pcl::PrincipalCurvatures >::feature_name_, and setNumberOfThreads().

## Member Function Documentation

## computeFeature()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected

Estimate the principal curvature (eigenvector of the max eigenvalue), along with both the max (pc1) and min (pc2) eigenvalues for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ().

Parameters

  [out] | output | the resultant point cloud model dataset that contains the principal curvature estimates

Definition at line 130 of file principal_curvatures.hpp.

References computePointPrincipalCurvatures(), pcl::PCLBase< PointInT >::indices_, pcl::PCLBase< PointInT >::input_, pcl::isFinite(), pcl::Feature< PointInT, pcl::PrincipalCurvatures >::k_, pcl::FeatureFromNormals< PointInT, PointNT, pcl::PrincipalCurvatures >::normals_, pcl::Feature< PointInT, pcl::PrincipalCurvatures >::search_parameter_, and pcl::Feature< PointInT, pcl::PrincipalCurvatures >::searchForNeighbors().

## computePointPrincipalCurvatures()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::computePointPrincipalCurvatures | ( | const pcl::PointCloud< PointNT > & | normals,
|  | int | p_idx,
|  | const pcl::Indices & | indices,
|  | float & | pcx,
|  | float & | pcy,
|  | float & | pcz,
|  | float & | pc1,
|  | float & | pc2 )

Perform Principal Components Analysis (PCA) on the point normals of a surface patch in the tangent plane of the given point normal, and return the principal curvature (eigenvector of the max eigenvalue), along with both the max (pc1) and min (pc2) eigenvalues.

Parameters

  [in] | normals | the point cloud normals
  [in] | p_idx | the query point at which the least-squares plane was estimated
  [in] | indices | the point cloud indices that need to be used
  [out] | pcx | the principal curvature X direction
  [out] | pcy | the principal curvature Y direction
  [out] | pcz | the principal curvature Z direction
  [out] | pc1 | the max eigenvalue of curvature
  [out] | pc2 | the min eigenvalue of curvature

Definition at line 67 of file principal_curvatures.hpp.

References pcl::computeCorrespondingEigenVector(), and pcl::eigen33().

Referenced by computeFeature().

## setNumberOfThreads()

template<typename PointInT, typename PointNT, typename PointOutT>

void pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::setNumberOfThreads | ( | unsigned int | nr_threads | ) |

Initialize the scheduler and set the number of threads to use.

The default behavior is single threaded exectution

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value to automatic)

Definition at line 50 of file principal_curvatures.hpp.

References threads_.

Referenced by PrincipalCurvaturesEstimation().

## Member Data Documentation

## chunk_size_

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

int pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::chunk_size_

protected

Chunk size for (dynamic) scheduling.

Definition at line 118 of file principal_curvatures.h.

Referenced by PrincipalCurvaturesEstimation().

## threads_

template<typename PointInT, typename PointNT, typename PointOutT = pcl::PrincipalCurvatures>

unsigned int pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::threads_

protected

The number of threads the scheduler should use.

Definition at line 115 of file principal_curvatures.h.

Referenced by setNumberOfThreads().

The documentation for this class was generated from the following files:

- pcl/features/principal_curvatures.h
- pcl/features/impl/principal_curvatures.hpp